;; 1. Add all the natural numbers below 1000 that are multiples of 3 or 5

;; count down, modulus of x == 0, sum

(defun range (low high)
  (loop for ii from low to (- high 1)
	collect ii))

(defun three-or-five-p (num)
  (or (= 0 (mod num 5))
      (= 0 (mod num 3))))

(defun filter-for-targets (numbers)
  (remove-if-not #'three-or-five-p
	     numbers))

(defun target-numbers ()
  (filter-for-targets (range 1 1000)))

(format t "sum: ~a~&" (apply #'+ (target-numbers)))
(format t "sum: ~a~&" (apply #'+ (filter-for-targets (range 1 10))))